//-----------------------------------------------------------------------------
/*
 * Zadanie2.java
 *
 * Vytvorene 18.11. 2003 23:27
 */
//-----------------------------------------------------------------------------
/**
 * Zadanie z predmetu 'Technologie JAVA' - Zadanie2.java
 * @author  Roman Brik
 *          FEI TUKE KPI 2. ronk SPZ
 */
//-----------------------------------------------------------------------------
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
//-----------------------------------------------------------------------------
public class Zadanie2 extends JFrame {
  Panel pnl;
  TextField tfMeno;
  List lstZoznam;
  Button btnClear, btnSave;
  String sFileName, sPath;

//-------------------------------------
/** Konstruktor - vlozi do okna vsetky komponenty */
  public Zadanie2() {
    Label lbl;

    super.setTitle("Vkladanie a vber mien");
    this.setResizable(false); // velkost okna bude pevna
    this.setSize(303, 338);
    this.addWindowListener(new ZavriOkno()); // udalost pre zatvorenie okna

    pnl = new Panel();
    getContentPane().add(pnl);
    pnl.setLayout(null); // komponenty budu ukladane na presne bodove pozicie

    lbl = new Label("Zadaj meno:");
    lbl.setBounds(8, 5, 280, 15);
    pnl.add(lbl);

    tfMeno = new TextField();
    tfMeno.setBounds(8, 22, 280, 20);
    pnl.add(tfMeno);
    tfMeno.addKeyListener(new PridajMeno());

    lbl = new Label("Zoznam mien:");
    lbl.setBounds(8, 50, 280, 15);
    pnl.add(lbl);

    lstZoznam = new List();
    lstZoznam.setBounds(8, 67, 280, 200);
    pnl.add(lstZoznam);

    pridajTlacidlo("Nata", 8, 280, new NacitajZoznam());
    btnSave = pridajTlacidlo("Uloi", 75, 280, new UlozZoznam());
    btnSave.setEnabled(false);
    btnClear = pridajTlacidlo("Vyisti", 142, 280, new VycistiZoznam());
    btnClear.setEnabled(false);
    pridajTlacidlo("Koniec", 228, 280, new TlacKoniec());
  } // end of public Zadanie2()

//-------------------------------------
/** main() - vytvori a zobrazi formular okna programu */
  public static void main(String[] args) { //throws IOException {
    new Zadanie2().setVisible(true);
  }

//-------------------------------------
/** pridajTlacidlo() - prida na formular tlacidlo
 *  a vrati ukazovatel na vytvorene tlacidlo */
  public Button pridajTlacidlo(String name, int x, int y, ActionListener al) {
    Button btn = new Button(name);
    btn.setBounds(x, y, 60, 25);
    pnl.add(btn);
    if (al != null)
      btn.addActionListener(al);
    return btn;
  }

//-------------------------------------
/** menoSuboru() - otvori dialog pre vyber mena suboru
 *  cesta k suboru a meno budu v sFileName a sPath
 *  ak dojde k chybe alebo sa dialog zrusi sFileName = null*/
  public void menoSuboru(int mod) {
    String s;
    if (mod == FileDialog.SAVE)
      s = "Ulozenie zoznamu...";
    else
      s = "Natanie zoznamu...";
    FileDialog fd = new FileDialog(this, s, mod);
    fd.setFile("*.lst");
    fd.show();
    sFileName = fd.getFile();
    sPath = fd.getDirectory();
  }

//-------------------------------------
/** ulozZoznam() - ulozi do zvoleneho suboru cely zoznam mien */
  public void ulozZoznam() { // throws IOException {
      int i;
      File f = null;
      FileWriter fwr = null;

      f = new File(sPath, sFileName);
      try {
        if (f.exists())
          f.delete();
        f.createNewFile();
        fwr = new FileWriter(f);
        for (i = 0; i < lstZoznam.getItemCount(); i++) {
          fwr.write(lstZoznam.getItem(i));
          fwr.write(System.getProperty("line.separator"));
        }
        fwr.close();
      }
      catch (IOException e) {
        System.out.println("Chyba pri prci so sborom: " + sPath + sFileName);
      }
  }

//-------------------------------------
/** nacitajZoznam() - nacita zoznam mien zo zvoleneho suboru
 * kazde meno musi byt na osobitnom riadku */
  public void nacitajZoznam() { // throws IOException {
      File f = null;
      FileReader frd = null;
      BufferedReader brd = null;
      String line;

      f = new File(sPath, sFileName);
      lstZoznam.removeAll();
      try {
        if (!f.exists())
          return;
        frd = new FileReader(f);
        brd = new BufferedReader(frd);
        while ((line = brd.readLine()) != null)
          lstZoznam.add(line);
        frd.close();
      }
      catch (IOException e) {
        System.out.println("Chyba pri prci so sborom: " + sPath + sFileName);
      }
  }

//-----------------------------------------------------------------------------
//*****************************************************************************
//-----------------------------------------------------------------------------
// Obsluhy jednotlivych udalosti za pomoci vnutornych tried pre kazdu udalost
// osobitne
//-----------------------------------------------------------------------------
//*****************************************************************************
//-----------------------------------------------------------------------------
/** obsluha udalosti ukoncenia programu uzavretim okna */
  class ZavriOkno extends WindowAdapter {
    public void windowClosing(WindowEvent e) {
      System.exit(0);
    }
  } // end of class ZavriOkno
//-----------------------------------------------------------------------------
/** obsluha udalosti stlacenia klavesy Enter v TextFielde */
  class PridajMeno extends KeyAdapter {
    public void keyTyped(KeyEvent e) {
      if (e.getKeyChar() == e.VK_ENTER) { // bola stlacena klavesa Enter?
        String s;
        int i, idx;

        idx = -1;
        s = tfMeno.getText().trim(); // odstran nadbytocne medzery
        for (i = 0; i < lstZoznam.getItemCount(); i++) { // zisti, ci uz take
          if (s.compareTo(lstZoznam.getItem(i)) == 0)    // meno existuje
            idx = i;                                     // ano - jeho index
        }
        if (idx == -1) {
          lstZoznam.add(s); // pridaj do zoznamu nove meno
          idx = lstZoznam.getItemCount() - 1;
        }
        lstZoznam.select(idx);  // oznac pridane alebo najdene meno
        tfMeno.setText(""); // zmaz editacne okienko
        btnClear.setEnabled(true);
        btnSave.setEnabled(true);
      }
    }
  } // end of class PridajMeno
//-----------------------------------------------------------------------------
/** obsluha udalosti stlacenia tlacidla Nacitaj */
  class NacitajZoznam implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      menoSuboru(FileDialog.LOAD);
      if (sFileName == null)
        return;
      nacitajZoznam();
      if (lstZoznam.getItemCount() > 0) {
        btnClear.setEnabled(true);
        btnSave.setEnabled(true);
      }
      else {
        btnClear.setEnabled(false);
        btnSave.setEnabled(false);
      }

      tfMeno.requestFocus();
    }
  } // end of class NacitajZoznam
//-----------------------------------------------------------------------------
/** obsluha udalosti stlacenia tlacidla Ulozit */
  class UlozZoznam implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      menoSuboru(FileDialog.SAVE);
      if (sFileName == null)
        return;
      ulozZoznam();

//      btnSave.setEnabled(false);
      tfMeno.requestFocus();
    }
  } // end of class UlozZoznam
//-----------------------------------------------------------------------------
/** obsluha udalosti stlacenia tlacidla Vycistit */
  class VycistiZoznam implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      lstZoznam.removeAll();
      btnClear.setEnabled(false);
      btnSave.setEnabled(false);
      tfMeno.requestFocus();
    }
  } // end of class VycistiZoznam
//-----------------------------------------------------------------------------
/** obsluha udalosti stlacenia tlacidla Koniec */
  class TlacKoniec implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      System.exit(0);
    }
  }
} // end of class TlacKoniec
//-----------------------------------------------------------------------------
